/****************************************************************************
 * Copyright (C) 2015 Dimok
 * Modified by Maschell, 2016 for GX2_GUI_Template
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/
#include "MainWindowTV.h"
#include "utils/logger.h"

MainWindowTV::MainWindowTV(int w, int h)
    : GuiMainWindowScreen(w, h)
    , width(w)
    , height(h)
    ,bgImageColor(w, h, (GX2Color){ 0, 0, 0, 0 })
{
    bgImageColor.setImageColor((GX2Color){  248, 248, 249, 255 }, 0);
    bgImageColor.setImageColor((GX2Color){  248, 248, 249, 255 }, 1);
    bgImageColor.setImageColor((GX2Color){  248, 248, 249, 255 }, 2);
    bgImageColor.setImageColor((GX2Color){  248, 248, 249, 255 }, 3);
    append(&bgImageColor);
}

MainWindowTV::~MainWindowTV()
{
    remove(&bgImageColor);
}

void MainWindowTV::draw(CVideo *v){
	GuiMainWindowScreen::draw(v);
	//gets called on every frame fro drawing
}


void MainWindowTV::update(GuiController * c){
    GuiMainWindowScreen::update(c);
    //CONTROLLER UPDATE!!!
}

void MainWindowTV::process(){
    GuiMainWindowScreen::process();
    //gets called on every frame
}
